package me.kies.XRayDeath;

import java.io.BufferedInputStream;
import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.InputStreamReader;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.Properties;
import java.util.logging.Logger;

import org.bukkit.command.Command;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;
import org.bukkit.plugin.PluginDescriptionFile;
import org.bukkit.plugin.java.JavaPlugin;
import org.bukkit.ChatColor;

import com.nijiko.permissions.PermissionHandler;
import com.nijikokun.bukkit.Permissions.Permissions;
import org.bukkit.plugin.Plugin;


public class XRayDeath extends JavaPlugin {
	
	public PermissionHandler permissionHandler;
	
	public static XRayDeath plugin;
	public final Logger logger = Logger.getLogger("Minecraft");
	
	public Integer warn = 1;
	public Integer warnlevel = 5;
	public Integer warntime = 60;
	public Integer warnplayer = 1;
	public Integer skipcreative = 1;
	public Integer useMySql = 0;
	public String MySqlUser = "";
	public String MySqlHost = "";
	public String MySqlPassword = "";
	public String MySqlDatabase = "";
	public Integer MySqlPort = 3306;
	
	@Override
	public void onDisable() {
		PluginDescriptionFile pdfFile = this.getDescription();
		this.logger.info(pdfFile.getName() + " is now disabled!");
	}
	
	@Override
	public void onEnable () {
		
		setupPermissions();
		
		File file = new File("plugins/XRayDeath");
		boolean exists = file.exists();
		if (!exists) {
			file.mkdir();
		}
		
		file = new File("plugins/XRayDeath/config.cfg");
		exists = file.exists();
		if (!exists) {
			try {
				FileWriter fstream = new FileWriter("plugins/XRayDeath/config.cfg");
				BufferedWriter out = new BufferedWriter(fstream);
				out.write("warn=true");
				out.newLine();
				out.write("warnlevel=9");
				out.newLine();
				out.write("warntime=60");
				out.newLine();
				out.write("warnplayer=false");
				out.newLine();
				out.write("skipcreative=true");
				out.newLine();
				out.write("useMySql=false");
				out.newLine();
				out.write("MySqlUser=");
				out.newLine();
				out.write("MySqlHost=localhost");
				out.newLine();
				out.write("MySqlPassword=");
				out.newLine();
				out.write("MySqlDatabase=");
				out.newLine();
				out.write("MySqlPort=3306");
				out.close();
			} catch (Exception e) {
				logger.info("xRayDeath: cannot write file: " + file.getName());
				return;
			}
		}
		
		warn = 1;
		warnlevel = 9;
		warntime = 60;
		warnplayer = 1;
		skipcreative = 1;
		
		try {
            Properties pro = new Properties();
            BufferedInputStream stream = new BufferedInputStream(new FileInputStream("plugins/XRayDeath/config.cfg"));
            pro.load(stream);
            
            if (pro.getProperty("warn") != null && pro.getProperty("warn").contentEquals("true")) {
            	warn = 1;
            } else {
            	warn = 0;
            }
            
            if (pro.getProperty("skipcreative") != null && pro.getProperty("skipcreative").contentEquals("true")) {
            	skipcreative = 1;
            } else {
            	skipcreative = 0;
            }
            
            if (pro.getProperty("warnplayer") != null && pro.getProperty("warnplayer").contentEquals("true")) {
            	warnplayer = 1;
            } else {
            	warnplayer = 0;
            }
            
            if (pro.getProperty("warnlevel") != null) {
            	warnlevel = Integer.parseInt(pro.getProperty("warnlevel"));
            }
            
            if (pro.getProperty("warntime") != null) {
            	warntime = Integer.parseInt(pro.getProperty("warntime"));
            }
            
            if (pro.getProperty("useMySql") != null && pro.getProperty("useMySql").contentEquals("true")) {
            	useMySql = 1;
            } else {
            	useMySql = 0;
            }
            
            if (pro.getProperty("MySqlUser") != null) {
            	MySqlUser = pro.getProperty("MySqlUser");
            }
            
            if (pro.getProperty("MySqlHost") != null) {
            	MySqlHost = pro.getProperty("MySqlHost");
            }
            
            if (pro.getProperty("MySqlPassword") != null) {
            	MySqlPassword = pro.getProperty("MySqlPassword");
            }
            
            if (pro.getProperty("MySqlDatabase") != null) {
            	MySqlDatabase = pro.getProperty("MySqlDatabase");
            }
            
            if (pro.getProperty("MySqlPort") != null) {
            	MySqlPort = Integer.parseInt(pro.getProperty("MySqlPort"));
            }
            
            stream.close();
        } catch(Exception ex) {
        	logger.info("xRayDeath: cannot read file: plugins/XRayDeath/config.cfg");
			return;
        }
		
		getServer().getPluginManager().registerEvents(new myBlockListener(this), this);
		
		PluginDescriptionFile pdfFile = this.getDescription();
		this.logger.info(pdfFile.getName() + " version " + pdfFile.getVersion() + " is now enabled!");
	}
	
	private void setupPermissions() {
		if (permissionHandler != null) {
			return;
		}
		
		Plugin permissionsPlugin = this.getServer().getPluginManager().getPlugin("Permissions");
		
		if (permissionsPlugin == null) {
			logger.info("Permissions system not detected, defaulting to OP.");
			return;
		}
		
		permissionHandler = ((Permissions) permissionsPlugin).getHandler();
		logger.info("Found and will use plugin Permissions");
	}
	
	public boolean onCommand(CommandSender sender, Command cmd, String commandLabel, String[] args){
		Player player = null;
		if (sender instanceof Player) {
			player = (Player) sender;
		}
		
		String playername;
		
		if(cmd.getName().equalsIgnoreCase("xrcheck") || cmd.getName().equalsIgnoreCase("xrc")) {
			
				if (player != null && permissionHandler == null && !player.isOp()) {
					sender.sendMessage(ChatColor.RED + "Error, missing permission xRayDeath.check!");
					return true;
				}
				if (player != null && permissionHandler != null && !permissionHandler.has(player, "xRayDeath.check")) {
					sender.sendMessage(ChatColor.RED + "Error, missing permission xRayDeath.check!");
					return true;
				}
				
				if (args.length != 1) {
					sender.sendMessage(ChatColor.RED + "Error, usage: /xrcheck [player]");
					return true;
				} else {
				
					Player p = sender.getServer().getPlayer(args[0]);
					
					
					if (p != null) {
						playername = p.getName().toLowerCase();
					} else {
						playername = args[0].toLowerCase();
					}
					
					if (useMySql != 1) {
					
						File file = new File("plugins/XRayDeath/" + playername + ".dat");
						if(!file.exists()) {
							sender.sendMessage(ChatColor.RED + "Error, no profile for player: " + playername);
							return true;
						}
						
						String[] strLine = new String[5];
						int index = 0;
						
						try {
						    FileInputStream fstream = new FileInputStream("plugins/XRayDeath/" + playername + ".dat");
						    DataInputStream in = new DataInputStream(fstream);
						    BufferedReader br = new BufferedReader(new InputStreamReader(in));
						    
						    
						    while ((strLine[index] = br.readLine()) != null)   {
						    	
						    	index++;
						    	if (index >= strLine.length) {
						    		break;
						    	}
						      
						    }
						    
						    in.close();
						} catch (Exception e) { return true; }
						
						int xStone = 0;
					    if (strLine[0] != null) {
					    	xStone = Integer.valueOf(strLine[0]).intValue();
					    }
					    int xDiamond = 0;
						if (strLine[1] != null) {
							xDiamond = Integer.valueOf(strLine[1]).intValue();
					    }
						int xGold = 0;
					    if (strLine[2] != null) {
					    	xGold = Integer.valueOf(strLine[2]).intValue();
					    }
					    int xIron = 0;
					    if (strLine[3] != null) {
					    	xIron = Integer.valueOf(strLine[3]).intValue();
					    }
					    
					    float xAll = (xStone + xDiamond + xGold + xIron);
					    
					    float pStone = xStone / xAll * 100;
					    float pDiamond = xDiamond / xAll * 100;
					    float pGold = xGold / xAll * 100;
					    float pIron = xIron / xAll * 100;
					    
					    String sStone = Float.toString(pStone);
					    String sDiamond = Float.toString(pDiamond);
					    String sGold = Float.toString(pGold);
					    String sIron = Float.toString(pIron);
					    
					    if (sStone.length() > 4) {
					    	sStone = sStone.substring(0, 4);
					    }
					    if (sDiamond.length() > 4) {
					    	sDiamond = sDiamond.substring(0, 4);
					    }
					    if (sGold.length() > 4) {
					    	sGold = sGold.substring(0, 4);
					    }
					    if (sIron.length() > 4) {
					    	sIron = sIron.substring(0, 4);
					    }
					    
					    ChatColor cStone = ChatColor.WHITE;
					    ChatColor cDiamond = ChatColor.GREEN;
					    ChatColor cGold = ChatColor.GREEN;
					    ChatColor cIron = ChatColor.GREEN;
					    
					    int xLevel = 0;
					    
					    if (pDiamond >= 5) {
					    	cDiamond = ChatColor.RED;
					    	xLevel = xLevel + 5;
					    } else if (pDiamond >= 3) {
					    	cDiamond = ChatColor.DARK_PURPLE;
					    	xLevel = xLevel + 3;
					    }
					    
					    if (pGold >= 16) {
					    	cGold = ChatColor.RED;
					    	xLevel = xLevel + 5;
					    } else if (pGold >= 8) {
					    	cGold = ChatColor.DARK_PURPLE;
					    	xLevel = xLevel + 2;
					    }
					    
					    if (pIron >= 24) {
					    	cIron = ChatColor.RED;
					    	xLevel = xLevel + 5;
					    } else if (pIron >= 12) {
					    	cIron = ChatColor.DARK_PURPLE;
					    	xLevel++;
					    }
					    
					    sender.sendMessage("xRayDeath Profile for: " + ChatColor.BLUE + playername);
					    sender.sendMessage("----------------------------------");
					    sender.sendMessage(cStone +   "Mined Blocks: " + String.valueOf((int)xAll));
					    sender.sendMessage(cStone +   "Stone: " + String.valueOf(xStone) + " - (%" + sStone + ")");
					    sender.sendMessage(cDiamond + "Diamond: " + String.valueOf(xDiamond) + " - (%" + sDiamond + ")");
					    sender.sendMessage(cGold +    "Gold: " + String.valueOf(xGold) + " - (%" + sGold + ")");
					    sender.sendMessage(cIron +    "Iron: " + String.valueOf(xIron) + " - (%" + sIron + ")");
					    sender.sendMessage("----------------------------------");
					    sender.sendMessage("xRay Level (max. 20): " + String.valueOf(xLevel));
					    
					    return true;
					    
					} else { // MySql
						
						try {
							Class.forName("com.mysql.jdbc.Driver");
					        Connection con = DriverManager.getConnection("jdbc:mysql://" + MySqlHost + ":"+ MySqlPort +"/"+ MySqlDatabase, MySqlUser, MySqlPassword);
					        
					        PreparedStatement statement = con.prepareStatement("SELECT * FROM `xraydeath` WHERE `user` = '" + playername + "'");
					        ResultSet result = statement.executeQuery();
					        
					        if (result.next()) {
					       
					        	int xStone = result.getInt(2);
							    int xDiamond = result.getInt(5);
								int xGold = result.getInt(4);
							    int xIron = result.getInt(3);
							    
							    float xAll = (xStone + xDiamond + xGold + xIron);
							    
							    float pStone = xStone / xAll * 100;
							    float pDiamond = xDiamond / xAll * 100;
							    float pGold = xGold / xAll * 100;
							    float pIron = xIron / xAll * 100;
							    
							    String sStone = Float.toString(pStone);
							    String sDiamond = Float.toString(pDiamond);
							    String sGold = Float.toString(pGold);
							    String sIron = Float.toString(pIron);
							    
							    if (sStone.length() > 4) {
							    	sStone = sStone.substring(0, 4);
							    }
							    if (sDiamond.length() > 4) {
							    	sDiamond = sDiamond.substring(0, 4);
							    }
							    if (sGold.length() > 4) {
							    	sGold = sGold.substring(0, 4);
							    }
							    if (sIron.length() > 4) {
							    	sIron = sIron.substring(0, 4);
							    }
							    
							    ChatColor cStone = ChatColor.WHITE;
							    ChatColor cDiamond = ChatColor.GREEN;
							    ChatColor cGold = ChatColor.GREEN;
							    ChatColor cIron = ChatColor.GREEN;
							    
							    int xLevel = 0;
							    
							    if (pDiamond >= 5) {
							    	cDiamond = ChatColor.RED;
							    	xLevel = xLevel + 5;
							    } else if (pDiamond >= 3) {
							    	cDiamond = ChatColor.DARK_PURPLE;
							    	xLevel = xLevel + 3;
							    }
							    
							    if (pGold >= 16) {
							    	cGold = ChatColor.RED;
							    	xLevel = xLevel + 5;
							    } else if (pGold >= 8) {
							    	cGold = ChatColor.DARK_PURPLE;
							    	xLevel = xLevel + 2;
							    }
							    
							    if (pIron >= 24) {
							    	cIron = ChatColor.RED;
							    	xLevel = xLevel + 5;
							    } else if (pIron >= 12) {
							    	cIron = ChatColor.DARK_PURPLE;
							    	xLevel++;
							    }
							    
							    sender.sendMessage("xRayDeath Profile for: " + ChatColor.BLUE + playername);
							    sender.sendMessage("----------------------------------");
							    sender.sendMessage(cStone +   "Mined Blocks: " + String.valueOf((int)xAll));
							    sender.sendMessage(cStone +   "Stone: " + String.valueOf(xStone) + " - (%" + sStone + ")");
							    sender.sendMessage(cDiamond + "Diamond: " + String.valueOf(xDiamond) + " - (%" + sDiamond + ")");
							    sender.sendMessage(cGold +    "Gold: " + String.valueOf(xGold) + " - (%" + sGold + ")");
							    sender.sendMessage(cIron +    "Iron: " + String.valueOf(xIron) + " - (%" + sIron + ")");
							    sender.sendMessage("----------------------------------");
							    sender.sendMessage("xRay Level (max. 20): " + String.valueOf(xLevel));
							    
							    con.close();
							    return true;
					        	
					        } else {
					        	con.close();
					        	sender.sendMessage(ChatColor.RED + "Error, no profile for player: " + playername);
								return true;
					        }
					        
						} catch (Exception e) {
							e.printStackTrace();
							logger.info("Error while trying to read MySQL information.");
						}
						
					}
			}
		}
		
		if(cmd.getName().equalsIgnoreCase("xrclear") || cmd.getName().equalsIgnoreCase("xrcl")) {
				
				if (player != null && permissionHandler == null && !player.isOp()) {
					sender.sendMessage(ChatColor.RED + "Error, missing permission xRayDeath.clear!");
					return true;
				}
				if (player != null && permissionHandler != null && !permissionHandler.has(player, "xRayDeath.clear")) {
					sender.sendMessage(ChatColor.RED + "Error, missing permission xRayDeath.clear!");
					return true;
				}
				
				if (args.length != 1) {
					sender.sendMessage(ChatColor.RED + "Error, usage: /xrclear [player]");
					return true;
				} else {
					
					Player p = sender.getServer().getPlayer(args[0]);
					
					if (p != null) {
						playername = p.getName().toLowerCase();
					} else {
						playername = args[0].toLowerCase();
					}
					
					if (useMySql != 1) {
					
						File file = new File("plugins/XRayDeath/" + playername + ".dat");
						if(!file.exists()) {
							sender.sendMessage(ChatColor.RED + "Error, no profile for player: " + args[0]);
							return true;
						} else {
								
							file.delete();
							sender.sendMessage(ChatColor.RED + "xRay Profile for player " + playername + " deleted.");
							return true;
								
						}
						
					} else { //MySql
					
						try {
							Class.forName("com.mysql.jdbc.Driver");
					        Connection con = DriverManager.getConnection("jdbc:mysql://" + MySqlHost + ":"+ MySqlPort +"/"+ MySqlDatabase, MySqlUser, MySqlPassword);
					        
					        PreparedStatement statement = con.prepareStatement("SELECT * FROM `xraydeath` WHERE `user` = '" + playername + "'");
					        ResultSet result = statement.executeQuery();
					        
					        if (result.next()) {
					        	
					        	statement.execute("DELETE FROM `xraydeath` WHERE `user` = '" + playername + "'");
					        	
					        	con.close();
					        	sender.sendMessage(ChatColor.RED + "xRay Profile for player " + playername + " deleted.");
								return true;
					        } else {
					        	con.close();
					        	sender.sendMessage(ChatColor.RED + "Error, no profile for player: " + playername);
								return true;
					        }
						} catch (Exception e) {
							e.printStackTrace();
							logger.info("Error while trying to read MySQL information.");
						}
					}
						
				}
		}
		
		if(cmd.getName().equalsIgnoreCase("xrclearall") || cmd.getName().equalsIgnoreCase("xrcla")) {
				
				if (player != null && permissionHandler == null && !player.isOp()) {
					sender.sendMessage(ChatColor.RED + "Error, missing permission xRayDeath.clearall!");
					return true;
				}
				if (player != null && permissionHandler != null && !permissionHandler.has(player, "xRayDeath.clearall")) {
					sender.sendMessage(ChatColor.RED + "Error, missing permission xRayDeath.clearall!");
					return true;
				}
				
				if (args.length != 0) {
					sender.sendMessage(ChatColor.RED + "Error, usage: /xrclearall");
					return true;
				} else {
					
					if (useMySql != 1) {
						
						File dir = new File("plugins/XRayDeath");
						File[] files = dir.listFiles();
						
						for (File datei : files) {
							datei.delete();
						}
						sender.sendMessage(ChatColor.RED + "All xRay Profiles deleted.");
						return true;
						
					} else { //MySql
						try {
							Class.forName("com.mysql.jdbc.Driver");
					        Connection con = DriverManager.getConnection("jdbc:mysql://" + MySqlHost + ":"+ MySqlPort +"/"+ MySqlDatabase, MySqlUser, MySqlPassword);
					        
					        PreparedStatement statement = con.prepareStatement("SELECT COUNT(*) FROM `xraydeath`");
					        ResultSet result = statement.executeQuery();
					        
					        if (result.next()) {
					        	statement.execute("TRUNCATE TABLE  `xraydeath`");
					        	
					        	con.close();
					        	sender.sendMessage(ChatColor.RED + "All xRay Profiles deleted.");
								return true;
					        }
						} catch (Exception e) {
							e.printStackTrace();
							logger.info("Error while trying to read MySQL information.");
						}
					}
						
			}
		}
	
	if(cmd.getName().equalsIgnoreCase("xrsearch") || cmd.getName().equalsIgnoreCase("xrs")) {
			
			if (player != null && permissionHandler == null && !player.isOp()) {
				sender.sendMessage(ChatColor.RED + "Error, missing permission xRayDeath.search!");
				return true;
			}
			if (player != null && permissionHandler != null && !permissionHandler.has(player, "xRayDeath.search")) {
				sender.sendMessage(ChatColor.RED + "Error, missing permission xRayDeath.search!");
				return true;
			}
			
			if (args.length != 1) {
				sender.sendMessage(ChatColor.RED + "Error, usage: /xrsearch [maxlevel]");
				return true;
			} else {
				
				if (useMySql != 1) {
					File dir = new File("plugins/XRayDeath");
					File[] files = dir.listFiles();
					
					int xStone = 0;
					int xDiamond = 0;
					int xGold = 0;
					int xIron = 0;
					float xAll = 0;
					float pDiamond = 0;
				    float pGold = 0;
				    float pIron = 0;
					int xLevel = 0;
					int index = 0;
					String[] strLine = new String[5];
					
					int maxDisplay = 0;
					
					sender.sendMessage("xRayDeath searching levels: " + ChatColor.BLUE + args[0] + ChatColor.WHITE + "+");
				    sender.sendMessage("----------------------------------");
					
					for (File datei : files) {
						if (datei != null && datei.getName().contains(".dat")) {
							
							index = 0;
							xStone = 0;
							xDiamond = 0;
							xGold = 0;
							xIron = 0;
							xAll = 0;
							pDiamond = 0;
						    pGold = 0;
						    pIron = 0;
							xLevel = 0;
							index = 0;
							
							strLine = new String[5];
							
							try {
							    FileInputStream fstream = new FileInputStream("plugins/XRayDeath/" + datei.getName());
							    DataInputStream in = new DataInputStream(fstream);
							    BufferedReader br = new BufferedReader(new InputStreamReader(in));
							    
							    while ((strLine[index] = br.readLine()) != null)   {
							    	
							    	index++;
							    	if (index >= strLine.length) {
							    		break;
							    	}
							      
							    }
							    
							    in.close();
							} catch (Exception e) { logger.info("Error 2100"); }
							
						    if (strLine[0] != null) {
						    	xStone = Integer.valueOf(strLine[0]).intValue();
						    }
						    
							if (strLine[1] != null) {
								xDiamond = Integer.valueOf(strLine[1]).intValue();
						    }
							
						    if (strLine[2] != null) {
						    	xGold = Integer.valueOf(strLine[2]).intValue();
						    }
						    
						    if (strLine[3] != null) {
						    	xIron = Integer.valueOf(strLine[3]).intValue();
						    }
						    
						    xAll = (xStone + xDiamond + xGold + xIron);
						    
						    pDiamond = xDiamond / xAll * 100;
						    pGold = xGold / xAll * 100;
						    pIron = xIron / xAll * 100;
						    
						    xLevel = 0;
						    
						    if (pDiamond >= 5) {
						    	xLevel = xLevel + 5;
						    } else if (pDiamond >= 3) {
						    	xLevel = xLevel + 3;
						    }
						    
						    if (pGold >= 8) {
						    	xLevel = xLevel + 5;
						    } else if (pGold >= 5) {
						    	xLevel++;
						    }
						    
						    if (pIron >= 20) {
						    	xLevel = xLevel + 5;
						    } else if (pIron >= 12) {
						    	xLevel++;
						    }
						    
						    if (xLevel >= Integer.parseInt(args[0])) {
						    	
						    	sender.sendMessage(datei.getName().replace(".dat", "") + " (" + xLevel + ")");
						    	maxDisplay++;
						    	
						    	if (maxDisplay > 5) {
						    		sender.sendMessage("----------------------------------");
						    		return true;
						    	}
						    	
						    }
							
						}
					}
					
					sender.sendMessage("----------------------------------");
					
					return true;
					
				} else { //MySql
					
					sender.sendMessage("xRayDeath searching levels: " + ChatColor.BLUE + args[0] + ChatColor.WHITE + "+");
				    sender.sendMessage("----------------------------------");
					
					try {
						Class.forName("com.mysql.jdbc.Driver");
				        Connection con = DriverManager.getConnection("jdbc:mysql://" + MySqlHost + ":"+ MySqlPort +"/"+ MySqlDatabase, MySqlUser, MySqlPassword);
				        
				        PreparedStatement statement = con.prepareStatement("SELECT * FROM `xraydeath` WHERE `level` >= '" + args[0] + "' LIMIT 0,5");
				        ResultSet result = statement.executeQuery();
				        
				        while (result.next()) {
				        	
				        	sender.sendMessage(result.getString(1) + " (" + result.getInt(7) + ")");
				        
				        }
				        
				        con.close();
				        
				        sender.sendMessage("----------------------------------");
						return true;
					} catch (Exception e) {
						e.printStackTrace();
						logger.info("Error while trying to read MySQL information.");
					}
				}
			}
		}
		
		return true;
	//}
	}
}