package me.kies.XRayDeath;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.DataInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.util.logging.Logger;

import org.bukkit.Bukkit;
import org.bukkit.ChatColor;
import org.bukkit.GameMode;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.block.BlockBreakEvent;


public class myBlockListener implements Listener {
	
	public static XRayDeath plugin;
	//public static Material[] xBlocks = {Material.STONE, Material.COBBLESTONE, Material.DIAMOND_ORE, Material.GOLD_ORE, Material.IRON_ORE};
	
	public myBlockListener(XRayDeath instance) {
		plugin = instance;
	}
	
	public static Logger logger = Logger.getLogger("Minecraft");
	
	@EventHandler
	public void onBlockBreak (BlockBreakEvent event) {
		Material block = event.getBlock().getType();
		Player player = event.getPlayer();
		
		String world = player.getWorld().getName();
		
		//logger.info(world);
		
		if (plugin.permissionHandler != null && plugin.permissionHandler.has(player, "xRayDeath.skip." + world)) {
			return;
		}
		
		if (block != Material.STONE && block != Material.GOLD_ORE && block != Material.DIAMOND_ORE && block != Material.IRON_ORE && block != Material.COBBLESTONE) {
			return;
		}
		
		if (player.getGameMode() == GameMode.CREATIVE && plugin.skipcreative == 1) {
			return;
		}
		
		if (plugin.useMySql != 1) {

			File file = new File("plugins/XRayDeath");
			boolean exists = file.exists();
			if (!exists) {
				file.mkdir();
			}
			
			file = new File("plugins/XRayDeath/" + player.getName().toLowerCase() + ".dat");
			if(!file.exists()) {
				try {
					file.createNewFile();
				} catch (IOException e) {
					logger.info("xRayDeath: cannot write file: " + file.getName());
					return;
				}
			}
			
			String[] strLine = new String[5];
			int index = 0;
			
			try {
			    FileInputStream fstream = new FileInputStream("plugins/XRayDeath/" + player.getName().toLowerCase() + ".dat");
			    DataInputStream in = new DataInputStream(fstream);
			    BufferedReader br = new BufferedReader(new InputStreamReader(in));
			    
			    while ((strLine[index] = br.readLine()) != null)   {
			    	
			    	index++;
			    	if (index >= strLine.length) {
			    		break;
			    	}
			      
			    }
			    
			    in.close();
			} catch (Exception e) { return; }
			
			long lastMsg = 0;
			if (strLine[4] != null) {
				lastMsg = Long.valueOf(strLine[4]).longValue();
			}
		    
			int xStone = 0;
		    if (strLine[0] != null) {
		    	xStone = Integer.valueOf(strLine[0]).intValue();
		    }
		    int xDiamond = 0;
			if (strLine[1] != null) {
				xDiamond = Integer.valueOf(strLine[1]).intValue();
		    }
			int xGold = 0;
		    if (strLine[2] != null) {
		    	xGold = Integer.valueOf(strLine[2]).intValue();
		    }
		    int xIron = 0;
		    if (strLine[3] != null) {
		    	xIron = Integer.valueOf(strLine[3]).intValue();
		    }
					
			if (block == Material.STONE || block == Material.COBBLESTONE) {
				xStone = xStone + 1;
				//logger.info(player.getName() + " destroyed " + block + ", count: " + xStone);
			}
			
			if (block == Material.GOLD_ORE) {
				xGold = xGold + 1;
				//logger.info(player.getName() + " destroyed " + block + ", count: " + xGold);
			}
					
			if (block == Material.DIAMOND_ORE) {
				xDiamond = xDiamond + 1;
				//logger.info(player.getName() + " destroyed " + block + ", count: " + xDiamond);
			}
				
			if (block == Material.IRON_ORE) {
				xIron = xIron + 1;
				//logger.info(player.getName() + " destroyed " + block + ", count: " + xIron);
			}
			
			if (plugin.warn == 1) {
				float xAll = (xStone + xDiamond + xGold + xIron);

			    float pDiamond = xDiamond / xAll * 100;
			    float pGold = xGold / xAll * 100;
			    float pIron = xIron / xAll * 100;
			    
			    int xLevel = 0;
			    
			    if (pDiamond >= 5) {
			    	xLevel = xLevel + 5;
			    } else if (pDiamond >= 3) {
			    	xLevel = xLevel + 3;
			    }
			    
			    if (pGold >= 16) {
			    	xLevel = xLevel + 5;
			    } else if (pGold >= 8) {
			    	xLevel = xLevel + 2;
			    }
			    
			    if (pIron >= 24) {
			    	xLevel = xLevel + 4;
			    } else if (pIron >= 12) {
			    	xLevel++;
			    }
				
			    if (xLevel >= plugin.warnlevel) {
			    	
			    	if (System.currentTimeMillis() - lastMsg > ((plugin.warntime - xLevel) * 1000)) {
			    		
			    		if (plugin.warnplayer != 0) {
			    			player.sendMessage(ChatColor.RED + "[xRayDeath]" + ChatColor.WHITE + " Your xray level is above " + plugin.warnlevel + "/20.");
			    		}
			    		
						for(Player p : Bukkit.getServer().getOnlinePlayers()) {
							if (plugin.permissionHandler != null && plugin.permissionHandler.has(p, "xRayDeath.msg")) {
								p.sendMessage(ChatColor.RED + "[xRayDeath]" + ChatColor.WHITE + " Possible xRay user: " + ChatColor.BLUE + player.getName() + ChatColor.WHITE + ". xRay Level: " + String.valueOf(xLevel));
								lastMsg = System.currentTimeMillis();
							} else if (p.isOp()) {
								p.sendMessage(ChatColor.RED + "[xRayDeath]" + ChatColor.WHITE + " Possible xRay user: " + ChatColor.BLUE + player.getName() + ChatColor.WHITE + ". xRay Level: " + String.valueOf(xLevel));
								lastMsg = System.currentTimeMillis();
							}
					    }
			    	}
				
			    }
			}
			
			try {
				FileWriter fstream = new FileWriter("plugins/XRayDeath/" + player.getName().toLowerCase() + ".dat");
				BufferedWriter out = new BufferedWriter(fstream);
				out.write(String.valueOf(xStone));
				out.newLine();
				out.write(String.valueOf(xDiamond));
				out.newLine();
				out.write(String.valueOf(xGold));
				out.newLine();
				out.write(String.valueOf(xIron));
				out.newLine();
				out.write(String.valueOf(lastMsg));
				out.close();
			} catch (Exception e) {
				logger.info("xRayDeath: cannot write file: " + file.getName());
				return;
			}
		
		} else { //MySql
			
			long lastMsg = 0;
	    	int xStone = 0;
		    int xDiamond = 0;
			int xGold = 0;
		    int xIron = 0;
		    int xLevel = 0;
					
			if (block == Material.STONE || block == Material.COBBLESTONE) {
				xStone = xStone + 1;
			}
			
			if (block == Material.GOLD_ORE) {
				xGold = xGold + 1;
			}
					
			if (block == Material.DIAMOND_ORE) {
				xDiamond = xDiamond + 1;
			}
				
			if (block == Material.IRON_ORE) {
				xIron = xIron + 1;
			}
			
			try {
				Class.forName("com.mysql.jdbc.Driver");
		        Connection con = DriverManager.getConnection("jdbc:mysql://" + plugin.MySqlHost + ":"+ plugin.MySqlPort +"/"+ plugin.MySqlDatabase, plugin.MySqlUser, plugin.MySqlPassword);
		        
		        PreparedStatement statement = con.prepareStatement("SELECT * FROM `xraydeath` WHERE `user` = '" + player.getName().toLowerCase() + "'");
		        ResultSet result = statement.executeQuery();
		        
		        if (result.next()) {
		        	
					xStone = xStone + result.getInt(2);
					xIron = xIron + result.getInt(3);
					xGold = xGold + result.getInt(4);
					xDiamond = xDiamond + result.getInt(5);
		        	
					float xAll = (xStone + xDiamond + xGold + xIron);

				    float pDiamond = xDiamond / xAll * 100;
				    float pGold = xGold / xAll * 100;
				    float pIron = xIron / xAll * 100;
				    
				    if (pDiamond >= 5) {
				    	xLevel = xLevel + 5;
				    } else if (pDiamond >= 3) {
				    	xLevel = xLevel + 3;
				    }
				    
				    if (pGold >= 16) {
				    	xLevel = xLevel + 5;
				    } else if (pGold >= 8) {
				    	xLevel = xLevel + 2;
				    }
				    
				    if (pIron >= 24) {
				    	xLevel = xLevel + 4;
				    } else if (pIron >= 12) {
				    	xLevel++;
				    }
				    
				    if (plugin.warn == 1) {
		        		if (xLevel >= plugin.warnlevel) {
					    	
					    	if (System.currentTimeMillis() - lastMsg > ((plugin.warntime - xLevel) * 1000)) {
					    		
					    		if (plugin.warnplayer != 0) {
					    			player.sendMessage(ChatColor.RED + "[xRayDeath]" + ChatColor.WHITE + " Your xray level is above " + plugin.warnlevel + "/20.");
					    		}
					    		
					    		for(Player p : Bukkit.getServer().getOnlinePlayers()) {
									if (plugin.permissionHandler != null && plugin.permissionHandler.has(p, "xRayDeath.msg")) {
										p.sendMessage(ChatColor.RED + "[xRayDeath]" + ChatColor.WHITE + " Possible xRay user: " + ChatColor.BLUE + player.getName() + ChatColor.WHITE + ". xRay Level: " + String.valueOf(xLevel));
										lastMsg = System.currentTimeMillis();
									} else if (p.isOp()) {
										p.sendMessage(ChatColor.RED + "[xRayDeath]" + ChatColor.WHITE + " Possible xRay user: " + ChatColor.BLUE + player.getName() + ChatColor.WHITE + ". xRay Level: " + String.valueOf(xLevel));
										lastMsg = System.currentTimeMillis();
									}
							    }
					    	}
						
					    }
		        	}
		        	
		        	statement.execute("UPDATE xraydeath SET `stone` = '" + xStone + "', `iron` = '" + xIron + "', `gold` = '" + xGold + "', `diamond` = '" + xDiamond + "', `warntime` = '" + lastMsg + "', `level` = '" + xLevel + "' WHERE `user` = '" + player.getName().toLowerCase() + "'");
		        	
		        	
		        } else {
		        	statement.execute("INSERT INTO xraydeath (`user`, `stone`, `iron`, `gold`, `diamond`, `warntime`, `level`) VALUES ('" + player.getName().toLowerCase() + "', '" + xStone + "', '" + xIron + "', '" + xGold + "', '" + xDiamond + "', '" + lastMsg + "', '0')");
		        	
		        }
		        
		        con.close();
			} catch (Exception e) {
				e.printStackTrace();
				logger.info("Error while trying to read MySQL information.");
				return;
			}
	        
	        /*if(userExists = true)
	        {
	            statement.execute("UPDATE Users SET Username= '" + userName + "', IsUserOnline = '" + online + "' WHERE Username = '" + userName + "'");
	        }else
	        {
	            statement.execute("INSERT INTO Users (`Username`, `IsUserOnline`) VALUES ('" + userName + "','" + online + "')");
	        }*/
			
		}
		
	}

}
